"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var requireModule_1 = require("../requireModule");
var createCssPreprocessorRules = function (dev, stack) {
    var createRule;
    if (stack.hasAny('server')) {
        createRule = function (prep, ext) { return ({
            test: new RegExp("." + ext + "$"),
            use: dev ? [
                { loader: 'isomorphic-style-loader' },
                { loader: 'css-loader', options: { sourceMap: true } },
                { loader: 'postcss-loader', options: { sourceMap: true } },
                { loader: prep + "-loader", options: { sourceMap: true } }
            ] :
                [{ loader: 'ignore-loader' }],
        }); };
    }
    else if (stack.hasAny('web')) {
        createRule = function (prep, ext) { return ({
            test: new RegExp("." + ext + "$"),
            use: dev ? [
                { loader: 'style-loader' },
                { loader: 'css-loader', options: { sourceMap: true, importLoaders: 1 } },
                { loader: 'postcss-loader', options: { sourceMap: true } },
                { loader: prep + "-loader", options: { sourceMap: true } },
            ] : requireModule_1.default('extract-text-webpack-plugin').extract({
                fallback: 'style-loader',
                use: ['css-loader', 'postcss-loader', prep + "-loader"],
            }),
        }); };
    }
    var rules = [];
    if (createRule && stack.hasAny('sass')) {
        rules.push(createRule('sass', 'scss'));
    }
    if (createRule && stack.hasAny('less')) {
        rules.push(createRule('less', 'less'));
    }
    return rules;
};
var CssProcessorPlugin = (function () {
    function CssProcessorPlugin() {
    }
    CssProcessorPlugin.prototype.configure = function (builder, spin) {
        return {
            module: {
                rules: createCssPreprocessorRules(spin.dev, builder.stack)
            }
        };
    };
    return CssProcessorPlugin;
}());
exports.default = CssProcessorPlugin;
//# sourceMappingURL=CssProcessorPlugin.js.map