"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var requireModule_1 = require("../requireModule");
var ES6Plugin = (function () {
    function ES6Plugin() {
    }
    ES6Plugin.prototype.configure = function (builder, spin) {
        var rules = [];
        if (builder.stack.hasAny(['es6', 'react-native'])) {
            var babelRule_1 = {
                loader: requireModule_1.default.resolve('babel-loader'),
                options: {
                    cacheDirectory: spin.dev,
                    presets: [
                        requireModule_1.default.resolve('babel-preset-react'),
                        [requireModule_1.default.resolve('babel-preset-es2015'), { 'modules': false }],
                        requireModule_1.default.resolve('babel-preset-stage-0')
                    ],
                    plugins: [
                        requireModule_1.default.resolve('babel-plugin-transform-runtime'),
                        requireModule_1.default.resolve('babel-plugin-transform-decorators-legacy'),
                        requireModule_1.default.resolve('babel-plugin-transform-class-properties'),
                        [requireModule_1.default.resolve('babel-plugin-styled-components'), { 'ssr': spin.options.ssr }],
                    ].concat(spin.dev && spin.options.reactHotLoader ? [requireModule_1.default.resolve('react-hot-loader/babel')] : []),
                    only: ['*.js', '*.jsx'],
                },
            };
            var reactNativeRule_1;
            if (builder.stack.hasAny('react-native')) {
                reactNativeRule_1 = {
                    loader: requireModule_1.default.resolve('babel-loader'),
                    options: {
                        cacheDirectory: spin.dev,
                        presets: [requireModule_1.default.resolve('babel-preset-react-native')],
                        plugins: [
                            requireModule_1.default.resolve('haul/src/utils/fixRequireIssues'),
                        ],
                    },
                };
            }
            rules.push({
                test: /\.jsx?$/,
                exclude: builder.stack.hasAny(['react-native']) ?
                    /node_modules\/(?!react-native|@expo|expo|lottie-react-native|haul|pretty-format|react-navigation)$/ :
                    /node_modules/,
                use: [
                    (builder.stack.hasAny(['react-native']) ?
                        function (req) {
                            var result;
                            if (req.resource.indexOf('node_modules') >= 0) {
                                result = reactNativeRule_1;
                            }
                            else {
                                result = babelRule_1;
                            }
                            return result;
                        } :
                        babelRule_1),
                ],
            });
        }
        return {
            module: {
                rules: rules,
            }
        };
    };
    return ES6Plugin;
}());
exports.default = ES6Plugin;
//# sourceMappingURL=ES6Plugin.js.map